/*
   Control of various 433MHz devices
*/
#include <MySensor.h>
#include <SPI.h>
#include "My433Node.h"


//Definera upp sensor numret och enhetsdata p alla enheter som skall anslutas
const int LASLAMPA = 1;
const int KULLAMPA = 2;
const int WINLAMPA = 3;
const int VR_SOFFA = 4;
const int VR_FONSTER = 5;
const int END_SENSOR = 5;

Unit Units[END_SENSOR] =
{
   {
      LASLAMPA,            //SensorNb       = Sensor number i Controler 
      "11110101111010",    //AddressStream  = Address to 433 switch
      &Anslut              //protocol       = pointer to protocoll to use fpr this unit
   },
   { WINLAMPA, "11110101011110", &Anslut },
   { KULLAMPA, "10111101111010", &Anslut },

   { VR_SOFFA, "1011", &OldBig },
   { VR_FONSTER, "0011", &OldBig }
};


MySensor thisNode;
My433 LampNodes;

void setup()
{
   thisNode.begin(incomingMessage);
   //Send the sketch version information to the gateway and Controller
   thisNode.sendSketchInfo("Lampor", "1.0");

   //Reg all lamps
   for (int n=0; n<END_SENSOR; n++)
   {
      thisNode.present(Units[n].SensorNb, S_LIGHT);
   }

}

void loop()
{
   thisNode.process();
}

void incomingMessage(const MyMessage &message)
{
   if (message.type == V_LIGHT) 
   {
      for (int n=0; n<END_SENSOR; n++)
      {
         if (Units[n].SensorNb == message.sensor)
         {
            message.getBool() ? LampNodes.SetUnitON(&Units[n]) : LampNodes.SetUnitOFF(&Units[n]);
            break;
         }
      }
   } 
}
